import 'package:rx_command/rx_command.dart';
import 'package:store_ds/store_ds.dart';

final Map<String, RxStoreData> rxstore = {};

RxCommand<P, R> serveFromRx<P, R>(String key, [RxCommand<P, R> command]) =>
    rxstore[key] == null
        ? command == null ? NullThrownError() : command
        : rxstore[key].command;


@override
void save(String key, value) {
  store[currentStore][key] = value;

  if (rxstore.containsKey(key)) {
    final data = rxstore[key];
    if (data.storeName != null && currentStore != data.storeName)
      return;
    else
      data.command(value);
  }
}

// typedef RxCommandFunc<P,R> = RxCommand<P,R> Function(P value ,R result);

RxCommand<P, R> listenTo<P, R>(String key, RxCommand<P, R> command,
    [String storeName]) {
  rxstore[key] = RxStoreData(command, storeName);
  return command;
}

void logRxStore([String storeName]) {
  final map = rxstore.map((key, value) => MapEntry(
      '$key${value.storeName == null ? '' : ' from ' + value.storeName}',
      value.command));

  final str = listToString(createLogList('rxStore', map));
  print(str);
}

class RxStoreData {
  final RxCommand command;
  final String storeName;

  RxStoreData(this.command, [this.storeName]);
}